// This file is automatically generated from ./smb.pac.

#include "../src/smb_pac.h"

namespace binpac {


namespace SMB {
ContextSMB::ContextSMB()
	{
	}

ContextSMB::~ContextSMB()
	{
	}

SMB_dos_error::SMB_dos_error()
	{
	error_class_ = 0;
	reserved_ = 0;
	error_ = 0;
	}

SMB_dos_error::~SMB_dos_error()
	{
	}

int SMB_dos_error::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_dos_error"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_dos_error",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "error_class"
	error_class_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "reserved"
	reserved_ = *((uint8 const *) ((t_begin_of_data + 1)));
	
	// Parse "error"
	error_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
	
	BINPAC_ASSERT(t_begin_of_data + (4) <= t_end_of_data);
	return 4;
	}

SMB_error::SMB_error(int err_status_type)
	{
	val_case_index_ = -1;
	dos_error_ = 0;
	status_ = 0;
	err_status_type_ = err_status_type;
	}

SMB_error::~SMB_error()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "dos_error"
			{
			delete dos_error_;
			dos_error_ = 0;
			}
			break;
		case 1:
			// Clean up "status"
			{
			}
			break;
		}
	}

int SMB_error::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_error:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_error:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	val_case_index_ = err_status_type();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "dos_error"
			{
			dos_error_ = new SMB_dos_error();
			dos_error_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			}
			break;
		case 1:
			// Parse "status"
			{
			status_ = FixByteOrder(t_byteorder, *((int32 const *) (t_begin_of_data)));
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("SMB_error", val_case_index());
			break;
		}
	BINPAC_ASSERT(t_begin_of_data + (4) <= t_end_of_data);
	return 4;
	}

SMB_header::SMB_header()
	{
	command_ = 0;
	status_ = 0;
	flags_ = 0;
	flags2_ = 0;
	tid_ = 0;
	pid_ = 0;
	uid_ = 0;
	mid_ = 0;
	byteorder_ = littleendian;
	}

SMB_header::~SMB_header()
	{
	protocol_.free();
	delete status_;
	status_ = 0;
	}

int SMB_header::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "protocol"
	// Checking out-of-bound for "SMB_header:protocol"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_header:protocol",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_begin_of_data + 4;
	int t_protocol_string_length;
	t_protocol_string_length = 4;
	int t_protocol__size;
	t_protocol__size = t_protocol_string_length;
	protocol_.init(t_begin_of_data, t_protocol_string_length);
	}
	
	const_byteptr const t_dataptr_after_protocol = t_begin_of_data + (4);
	BINPAC_ASSERT(t_dataptr_after_protocol <= t_end_of_data);
	// Checking out-of-bound for "SMB_header:mid"
	if ( (t_dataptr_after_protocol + 26) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_header:mid",
			(((t_dataptr_after_protocol + 26) - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "command"
	command_ = *((uint8 const *) (t_dataptr_after_protocol));
	
	// Parse "status"
	// Parse "flags2"
	flags2_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_dataptr_after_protocol + 6))));
	err_status_type_ =  ( flags2() >> 14 )  & 1;
	status_ = new SMB_error(err_status_type());
	status_->Parse((t_dataptr_after_protocol + 1), t_end_of_data, byteorder());
	
	// Parse "flags"
	flags_ = *((uint8 const *) ((t_dataptr_after_protocol + 5)));
	
	
	
	// Parse "tid"
	tid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_dataptr_after_protocol + 20))));
	
	// Parse "pid"
	pid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_dataptr_after_protocol + 22))));
	
	// Parse "uid"
	uid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_dataptr_after_protocol + 24))));
	
	// Parse "mid"
	mid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_dataptr_after_protocol + 26))));
	
	int t_SMB_header__size;
	t_SMB_header__size = (t_dataptr_after_protocol + 28) - t_begin_of_data;
	unicode_ =  ( flags2() >> 15 )  & 1;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_header__size) <= t_end_of_data);
	return t_SMB_header__size;
	}

int const smb_header_length = 32;
SMB_body::SMB_body()
	{
	word_count_ = 0;
	parameter_words_ = 0;
	parameter_words__elem_ = 0;
	byte_count_ = 0;
	byteorder_ = littleendian;
	}

SMB_body::~SMB_body()
	{
	delete parameter_words_;
	}

int SMB_body::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_body:word_count"
	if ( t_begin_of_data + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_body:word_count",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "parameter_words"
	int t_parameter_words__arraylength;
	t_parameter_words__arraylength = word_count();
	parameter_words__elem_ = 0;
	int t_parameter_words__elem__it;
	t_parameter_words__elem__it = 0;
	int t_parameter_words__size;
	parameter_words_ = new vector<uint16>;
	parameter_words_->reserve(t_parameter_words__arraylength);
	const_byteptr t_parameter_words__elem__dataptr = (t_begin_of_data + 1);
	for (; t_parameter_words__elem__it < t_parameter_words__arraylength; ++t_parameter_words__elem__it)
		{
		// Checking out-of-bound for "SMB_body:parameter_words__elem"
		if ( t_parameter_words__elem__dataptr + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_body:parameter_words__elem",
				((t_parameter_words__elem__dataptr - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		parameter_words__elem_ = FixByteOrder(byteorder(), *((uint16 const *) (t_parameter_words__elem__dataptr)));
		parameter_words_->push_back(parameter_words__elem_);
		t_parameter_words__elem__dataptr += 2;
		BINPAC_ASSERT(t_parameter_words__elem__dataptr <= t_end_of_data);
		// Check &until(parameter_words__elem__dataptr >= end_of_data)
		if ( t_parameter_words__elem__dataptr >= t_end_of_data )
			{
			goto end_of_parameter_words;
			}
		}
end_of_parameter_words: ;
	t_parameter_words__size = t_parameter_words__elem__dataptr - ((t_begin_of_data + 1));
	
	const_byteptr const t_dataptr_after_parameter_words = (t_begin_of_data + 1) + (t_parameter_words__size);
	BINPAC_ASSERT(t_dataptr_after_parameter_words <= t_end_of_data);
	// Checking out-of-bound for "SMB_body:byte_count"
	if ( t_dataptr_after_parameter_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_body:byte_count",
			((t_dataptr_after_parameter_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) (t_dataptr_after_parameter_words)));
	
	int t_SMB_body__size;
	t_SMB_body__size = (t_dataptr_after_parameter_words + 2) - t_begin_of_data;
	body_length_ = 1 + word_count() * 2 + 2 + byte_count();
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_body__size) <= t_end_of_data);
	return t_SMB_body__size;
	}

SMB_ascii_string::SMB_ascii_string()
	{
	val_ = 0;
	val__elem_ = 0;
	}

SMB_ascii_string::~SMB_ascii_string()
	{
	delete val_;
	}

int SMB_ascii_string::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	int t_val__arraylength;
	val__elem_ = 0;
	int t_val__elem__it;
	t_val__elem__it = 0;
	int t_val__size;
	val_ = new vector<uint8>;
	const_byteptr t_val__elem__dataptr = t_begin_of_data;
	for (; /* forever */; ++t_val__elem__it)
		{
		// Checking out-of-bound for "SMB_ascii_string:val__elem"
		if ( t_val__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_ascii_string:val__elem",
				((t_val__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		val__elem_ = *((uint8 const *) (t_val__elem__dataptr));
		val_->push_back(val__elem_);
		t_val__elem__dataptr += 1;
		BINPAC_ASSERT(t_val__elem__dataptr <= t_end_of_data);
		// Check &until(val__elem__dataptr >= end_of_data)
		if ( t_val__elem__dataptr >= t_end_of_data )
			{
			goto end_of_val;
			}
		// Check &until( ( $element == ((int) 0) ) )
		if (  ( val__elem_ == 0 )  )
			{
			goto end_of_val;
			}
		}
end_of_val: ;
	t_val__size = t_val__elem__dataptr - (t_begin_of_data);
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

SMB_unicode_string::SMB_unicode_string(int offset)
	{
	s_ = 0;
	s__elem_ = 0;
	offset_ = offset;
	}

SMB_unicode_string::~SMB_unicode_string()
	{
	delete s_;
	}

int SMB_unicode_string::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	
	const_byteptr const t_dataptr_after_pad = t_begin_of_data + (offset() & 1);
	// Parse "s"
	int t_s__arraylength;
	s__elem_ = 0;
	int t_s__elem__it;
	t_s__elem__it = 0;
	int t_s__size;
	s_ = new vector<uint16>;
	const_byteptr t_s__elem__dataptr = t_dataptr_after_pad;
	for (; /* forever */; ++t_s__elem__it)
		{
		// Checking out-of-bound for "SMB_unicode_string:s__elem"
		if ( t_s__elem__dataptr + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_unicode_string:s__elem",
				((t_s__elem__dataptr - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		s__elem_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_s__elem__dataptr)));
		s_->push_back(s__elem_);
		t_s__elem__dataptr += 2;
		BINPAC_ASSERT(t_s__elem__dataptr <= t_end_of_data);
		// Check &until(s__elem__dataptr >= end_of_data)
		if ( t_s__elem__dataptr >= t_end_of_data )
			{
			goto end_of_s;
			}
		// Check &until( ( $element == ((int) 0) ) )
		if (  ( s__elem_ == 0 )  )
			{
			goto end_of_s;
			}
		}
end_of_s: ;
	t_s__size = t_s__elem__dataptr - (t_dataptr_after_pad);
	
	int t_SMB_unicode_string__size;
	const_byteptr const t_dataptr_after_s = t_dataptr_after_pad + (t_s__size);
	BINPAC_ASSERT(t_dataptr_after_s <= t_end_of_data);
	t_SMB_unicode_string__size = t_dataptr_after_s - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_unicode_string__size) <= t_end_of_data);
	return t_SMB_unicode_string__size;
	}

SMB_string::SMB_string(bool unicode, int offset)
	{
	val_case_index_ = -1;
	u_ = 0;
	a_ = 0;
	unicode_ = unicode;
	offset_ = offset;
	}

SMB_string::~SMB_string()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "u"
			{
			delete u_;
			u_ = 0;
			}
			break;
		case 0:
			// Clean up "a"
			{
			delete a_;
			a_ = 0;
			}
			break;
		}
	}

int SMB_string::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = unicode();
	switch ( val_case_index() )
		{
		case 1:
			// Parse "u"
			{
			u_ = new SMB_unicode_string(offset());
			int t_u__size;
			t_u__size = u_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = t_u__size;
			}
			break;
		case 0:
			// Parse "a"
			{
			a_ = new SMB_ascii_string();
			int t_a__size;
			t_a__size = a_->Parse(t_begin_of_data, t_end_of_data);
			t_val__size = t_a__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("SMB_string", val_case_index());
			break;
		}
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

SMB_andx::SMB_andx()
	{
	command_ = 0;
	reserved_ = 0;
	offset_ = 0;
	}

SMB_andx::~SMB_andx()
	{
	}

int SMB_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "SMB_andx"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_andx",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "command"
	command_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "reserved"
	reserved_ = *((uint8 const *) ((t_begin_of_data + 1)));
	
	// Parse "offset"
	offset_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
	
	BINPAC_ASSERT(t_begin_of_data + (4) <= t_end_of_data);
	return 4;
	}

SMB_generic_andx::SMB_generic_andx()
	{
	word_count_ = 0;
	andx_u_case_index_ = -1;
	andx_ = 0;
	byteorder_ = littleendian;
	}

SMB_generic_andx::~SMB_generic_andx()
	{
	switch ( andx_u_case_index() )
		{
		case 0:
			// Clean up "null"
			{
			}
			break;
		default:
			// Clean up "andx"
			{
			delete andx_;
			andx_ = 0;
			}
			break;
		}
	}

int SMB_generic_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_generic_andx:word_count"
	if ( t_begin_of_data + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_generic_andx:word_count",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx_u"
	int t_andx_u__size;
	andx_u_case_index_ = word_count();
	switch ( andx_u_case_index() )
		{
		case 0:
			// Parse "null"
			{
			t_andx_u__size = 0;
			}
			break;
		default:
			// Parse "andx"
			{
			andx_ = new SMB_andx();
			andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
			t_andx_u__size = 4;
			}
			break;
		}
	
	int t_SMB_generic_andx__size;
	const_byteptr const t_dataptr_after_andx_u = (t_begin_of_data + 1) + (t_andx_u__size);
	BINPAC_ASSERT(t_dataptr_after_andx_u <= t_end_of_data);
	t_SMB_generic_andx__size = t_dataptr_after_andx_u - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_generic_andx__size) <= t_end_of_data);
	return t_SMB_generic_andx__size;
	}

SMB_dialect::SMB_dialect()
	{
	bufferformat_ = 0;
	dialectname_ = 0;
	}

SMB_dialect::~SMB_dialect()
	{
	delete dialectname_;
	dialectname_ = 0;
	}

int SMB_dialect::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_dialect:bufferformat"
	if ( t_begin_of_data + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_dialect:bufferformat",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "bufferformat"
	bufferformat_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "dialectname"
	dialectname_ = new SMB_ascii_string();
	int t_dialectname__size;
	t_dialectname__size = dialectname_->Parse((t_begin_of_data + 1), t_end_of_data);
	
	int t_SMB_dialect__size;
	const_byteptr const t_dataptr_after_dialectname = (t_begin_of_data + 1) + (t_dialectname__size);
	BINPAC_ASSERT(t_dataptr_after_dialectname <= t_end_of_data);
	t_SMB_dialect__size = t_dataptr_after_dialectname - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_dialect__size) <= t_end_of_data);
	return t_SMB_dialect__size;
	}

SMB_negotiate::SMB_negotiate()
	{
	word_count_ = 0;
	byte_count_ = 0;
	dialects_ = 0;
	dialects__elem_ = 0;
	byteorder_ = littleendian;
	}

SMB_negotiate::~SMB_negotiate()
	{
	delete dialects__elem_;
	dialects__elem_ = 0;
	if ( dialects() )
		{
		for ( int i = 0; i < (int) dialects()->size(); ++i )
			{
			SMB_dialect * dialects__elem_ = (*dialects_)[i];
			delete dialects__elem_;
			dialects__elem_ = 0;
			}
		}
	delete dialects_;
	}

int SMB_negotiate::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_negotiate:byte_count"
	if ( (t_begin_of_data + 1) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_negotiate:byte_count",
			(1) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 1))));
	
	// Parse "dialects"
	int t_dialects__size;
	t_dialects__size = byte_count();
	// Checking out-of-bound for "SMB_negotiate:dialects"
	if ( (t_begin_of_data + 3) + (t_dialects__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_negotiate:dialects",
			(3) + (t_dialects__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = (t_begin_of_data + 3) + t_dialects__size;
	int t_dialects__arraylength;
	dialects__elem_ = 0;
	int t_dialects__elem__it;
	t_dialects__elem__it = 0;
	dialects_ = new vector<SMB_dialect *>;
	const_byteptr t_dialects__elem__dataptr = (t_begin_of_data + 3);
	for (; /* forever */; ++t_dialects__elem__it)
		{
		dialects__elem_ = new SMB_dialect();
		int t_dialects__elem__size;
		t_dialects__elem__size = dialects__elem_->Parse(t_dialects__elem__dataptr, t_end_of_data);
		dialects_->push_back(dialects__elem_);
		t_dialects__elem__dataptr += t_dialects__elem__size;
		BINPAC_ASSERT(t_dialects__elem__dataptr <= t_end_of_data);
		// Check &until(dialects__elem__dataptr >= end_of_data)
		if ( t_dialects__elem__dataptr >= t_end_of_data )
			{
			dialects__elem_ = 0;
			goto end_of_dialects;
			}
		dialects__elem_ = 0;
		}
end_of_dialects: ;
	}
	
	int t_SMB_negotiate__size;
	const_byteptr const t_dataptr_after_dialects = (t_begin_of_data + 3) + (t_dialects__size);
	BINPAC_ASSERT(t_dataptr_after_dialects <= t_end_of_data);
	t_SMB_negotiate__size = t_dataptr_after_dialects - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_negotiate__size) <= t_end_of_data);
	return t_SMB_negotiate__size;
	}

SMB_tree_connect_andx::SMB_tree_connect_andx(bool unicode)
	{
	word_count_ = 0;
	andx_ = 0;
	flags_ = 0;
	password_length_ = 0;
	byte_count_ = 0;
	password_ = 0;
	password__elem_ = 0;
	path_ = 0;
	service_ = 0;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_tree_connect_andx::~SMB_tree_connect_andx()
	{
	delete andx_;
	andx_ = 0;
	delete password_;
	delete path_;
	path_ = 0;
	delete service_;
	service_ = 0;
	}

int SMB_tree_connect_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_tree_connect_andx:byte_count"
	if ( (t_begin_of_data + 9) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_tree_connect_andx:byte_count",
			(9) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "flags"
	flags_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "password_length"
	password_length_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 9))));
	
	// Parse "password"
	int t_password__arraylength;
	t_password__arraylength = password_length();
	password__elem_ = 0;
	int t_password__elem__it;
	t_password__elem__it = 0;
	int t_password__size;
	password_ = new vector<uint8>;
	password_->reserve(t_password__arraylength);
	const_byteptr t_password__elem__dataptr = (t_begin_of_data + 11);
	for (; t_password__elem__it < t_password__arraylength; ++t_password__elem__it)
		{
		// Checking out-of-bound for "SMB_tree_connect_andx:password__elem"
		if ( t_password__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_tree_connect_andx:password__elem",
				((t_password__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		password__elem_ = *((uint8 const *) (t_password__elem__dataptr));
		password_->push_back(password__elem_);
		t_password__elem__dataptr += 1;
		BINPAC_ASSERT(t_password__elem__dataptr <= t_end_of_data);
		// Check &until(password__elem__dataptr >= end_of_data)
		if ( t_password__elem__dataptr >= t_end_of_data )
			{
			goto end_of_password;
			}
		}
end_of_password: ;
	t_password__size = t_password__elem__dataptr - ((t_begin_of_data + 11));
	
	const_byteptr const t_dataptr_after_password = (t_begin_of_data + 11) + (t_password__size);
	BINPAC_ASSERT(t_dataptr_after_password <= t_end_of_data);
	// Parse "path"
	path_ = new SMB_string(unicode(), (t_dataptr_after_password - t_begin_of_data));
	int t_path__size;
	t_path__size = path_->Parse(t_dataptr_after_password, t_end_of_data, byteorder());
	
	const_byteptr const t_dataptr_after_path = t_dataptr_after_password + (t_path__size);
	BINPAC_ASSERT(t_dataptr_after_path <= t_end_of_data);
	// Parse "service"
	service_ = new SMB_ascii_string();
	int t_service__size;
	t_service__size = service_->Parse(t_dataptr_after_path, t_end_of_data);
	
	int t_SMB_tree_connect_andx__size;
	const_byteptr const t_dataptr_after_service = t_dataptr_after_path + (t_service__size);
	BINPAC_ASSERT(t_dataptr_after_service <= t_end_of_data);
	t_SMB_tree_connect_andx__size = t_dataptr_after_service - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_tree_connect_andx__size) <= t_end_of_data);
	return t_SMB_tree_connect_andx__size;
	}

SMB_nt_create_andx::SMB_nt_create_andx(bool unicode)
	{
	word_count_ = 0;
	andx_ = 0;
	reserved_ = 0;
	name_length_ = 0;
	flags_ = 0;
	rest_words_ = 0;
	rest_words__elem_ = 0;
	byte_count_ = 0;
	name_ = 0;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_nt_create_andx::~SMB_nt_create_andx()
	{
	delete andx_;
	andx_ = 0;
	delete rest_words_;
	delete name_;
	name_ = 0;
	}

int SMB_nt_create_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_nt_create_andx:flags"
	if ( (t_begin_of_data + 8) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_nt_create_andx:flags",
			(8) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "reserved"
	reserved_ = *((uint8 const *) ((t_begin_of_data + 5)));
	
	// Parse "name_length"
	name_length_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 6))));
	
	// Parse "flags"
	flags_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 8))));
	
	// Parse "rest_words"
	int t_rest_words__arraylength;
	t_rest_words__arraylength = word_count() * 2 - 11;
	rest_words__elem_ = 0;
	int t_rest_words__elem__it;
	t_rest_words__elem__it = 0;
	int t_rest_words__size;
	rest_words_ = new vector<uint8>;
	rest_words_->reserve(t_rest_words__arraylength);
	const_byteptr t_rest_words__elem__dataptr = (t_begin_of_data + 12);
	for (; t_rest_words__elem__it < t_rest_words__arraylength; ++t_rest_words__elem__it)
		{
		// Checking out-of-bound for "SMB_nt_create_andx:rest_words__elem"
		if ( t_rest_words__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_nt_create_andx:rest_words__elem",
				((t_rest_words__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		rest_words__elem_ = *((uint8 const *) (t_rest_words__elem__dataptr));
		rest_words_->push_back(rest_words__elem_);
		t_rest_words__elem__dataptr += 1;
		BINPAC_ASSERT(t_rest_words__elem__dataptr <= t_end_of_data);
		// Check &until(rest_words__elem__dataptr >= end_of_data)
		if ( t_rest_words__elem__dataptr >= t_end_of_data )
			{
			goto end_of_rest_words;
			}
		}
end_of_rest_words: ;
	t_rest_words__size = t_rest_words__elem__dataptr - ((t_begin_of_data + 12));
	
	const_byteptr const t_dataptr_after_rest_words = (t_begin_of_data + 12) + (t_rest_words__size);
	BINPAC_ASSERT(t_dataptr_after_rest_words <= t_end_of_data);
	// Checking out-of-bound for "SMB_nt_create_andx:byte_count"
	if ( t_dataptr_after_rest_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_nt_create_andx:byte_count",
			((t_dataptr_after_rest_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) (t_dataptr_after_rest_words)));
	
	// Parse "name"
	name_ = new SMB_string(unicode(), ((t_dataptr_after_rest_words + 2) - t_begin_of_data));
	int t_name__size;
	t_name__size = name_->Parse((t_dataptr_after_rest_words + 2), t_end_of_data, byteorder());
	
	int t_SMB_nt_create_andx__size;
	const_byteptr const t_dataptr_after_name = (t_dataptr_after_rest_words + 2) + (t_name__size);
	BINPAC_ASSERT(t_dataptr_after_name <= t_end_of_data);
	t_SMB_nt_create_andx__size = t_dataptr_after_name - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_nt_create_andx__size) <= t_end_of_data);
	return t_SMB_nt_create_andx__size;
	}

SMB_read_andx::SMB_read_andx()
	{
	word_count_ = 0;
	andx_ = 0;
	fid_ = 0;
	offset_ = 0;
	max_count_ = 0;
	min_count_ = 0;
	max_count_high_ = 0;
	remaining_ = 0;
	offset_high_ = 0;
	byte_count_ = 0;
	byteorder_ = littleendian;
	}

SMB_read_andx::~SMB_read_andx()
	{
	delete andx_;
	andx_ = 0;
	}

int SMB_read_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_read_andx"
	if ( t_begin_of_data + (25) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx",
			(0) + (25), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "fid"
	fid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "offset"
	offset_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 7))));
	
	// Parse "max_count"
	max_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 11))));
	
	// Parse "min_count"
	min_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 13))));
	
	// Parse "max_count_high"
	max_count_high_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 15))));
	
	// Parse "remaining"
	remaining_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 17))));
	
	// Parse "offset_high"
	offset_high_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 19))));
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 23))));
	
	BINPAC_ASSERT(t_begin_of_data + (25) <= t_end_of_data);
	return 25;
	}

SMB_read_andx_response::SMB_read_andx_response()
	{
	word_count_ = 0;
	andx_ = 0;
	remaining_ = 0;
	data_compact_ = 0;
	reserved_ = 0;
	data_len_ = 0;
	data_offset_ = 0;
	data_len_high_ = 0;
	reserved2_ = 0;
	reserved2__elem_ = 0;
	byte_count_ = 0;
	byteorder_ = littleendian;
	}

SMB_read_andx_response::~SMB_read_andx_response()
	{
	delete andx_;
	andx_ = 0;
	delete reserved2_;
	data_.free();
	}

int SMB_read_andx_response::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_read_andx_response:byte_count"
	if ( (t_begin_of_data + 25) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx_response:byte_count",
			(25) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "remaining"
	remaining_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "data_compact"
	data_compact_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "reserved"
	reserved_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 9))));
	
	// Parse "data_len"
	data_len_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 11))));
	
	// Parse "data_offset"
	data_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 13))));
	
	// Parse "data_len_high"
	data_len_high_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 15))));
	
	// Parse "reserved2"
	int t_reserved2__arraylength;
	t_reserved2__arraylength = 4;
	reserved2__elem_ = 0;
	int t_reserved2__elem__it;
	t_reserved2__elem__it = 0;
	reserved2_ = new vector<uint16>;
	reserved2_->reserve(t_reserved2__arraylength);
	const_byteptr t_reserved2__elem__dataptr = (t_begin_of_data + 17);
	for (; t_reserved2__elem__it < t_reserved2__arraylength; ++t_reserved2__elem__it)
		{
		reserved2__elem_ = FixByteOrder(byteorder(), *((uint16 const *) (t_reserved2__elem__dataptr)));
		reserved2_->push_back(reserved2__elem_);
		t_reserved2__elem__dataptr += 2;
		BINPAC_ASSERT(t_reserved2__elem__dataptr <= t_end_of_data);
		// Check &until(reserved2__elem__dataptr >= end_of_data)
		if ( t_reserved2__elem__dataptr >= t_end_of_data )
			{
			goto end_of_reserved2;
			}
		}
end_of_reserved2: ;
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 25))));
	
	
	const_byteptr t_dataptr_after_pad = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad < (t_begin_of_data + 27) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:138:pad", (t_begin_of_data + 27) - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad = (t_begin_of_data + 27);
		}
	// Parse "data"
	int t_data__size;
	data_length_ = data_len_high() * 0x10000 + data_len();
	t_data__size = data_length();
	// Checking out-of-bound for "SMB_read_andx_response:data"
	if ( t_dataptr_after_pad + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_read_andx_response:data",
			((t_dataptr_after_pad - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad + t_data__size;
	int t_data_string_length;
	t_data_string_length = data_length();
	data_.init(t_dataptr_after_pad, t_data_string_length);
	}
	
	int t_SMB_read_andx_response__size;
	const_byteptr const t_dataptr_after_data = t_dataptr_after_pad + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_SMB_read_andx_response__size = t_dataptr_after_data - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_read_andx_response__size) <= t_end_of_data);
	return t_SMB_read_andx_response__size;
	}

SMB_write_andx::SMB_write_andx()
	{
	word_count_ = 0;
	andx_ = 0;
	fid_ = 0;
	offset_ = 0;
	reserved_ = 0;
	write_mode_ = 0;
	remaining_ = 0;
	data_len_high_ = 0;
	data_len_ = 0;
	data_offset_ = 0;
	rest_words_ = 0;
	rest_words__elem_ = 0;
	byte_count_ = 0;
	byteorder_ = littleendian;
	}

SMB_write_andx::~SMB_write_andx()
	{
	delete andx_;
	andx_ = 0;
	delete rest_words_;
	data_.free();
	}

int SMB_write_andx::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_write_andx:data_offset"
	if ( (t_begin_of_data + 23) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:data_offset",
			(23) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "fid"
	fid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "offset"
	offset_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 7))));
	
	// Parse "reserved"
	reserved_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 11))));
	
	// Parse "write_mode"
	write_mode_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 15))));
	
	// Parse "remaining"
	remaining_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 17))));
	
	// Parse "data_len_high"
	data_len_high_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 19))));
	
	// Parse "data_len"
	data_len_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 21))));
	
	// Parse "data_offset"
	data_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 23))));
	
	// Parse "rest_words"
	int t_rest_words__arraylength;
	t_rest_words__arraylength = word_count() * 2 - 25 + 1;
	rest_words__elem_ = 0;
	int t_rest_words__elem__it;
	t_rest_words__elem__it = 0;
	int t_rest_words__size;
	rest_words_ = new vector<uint8>;
	rest_words_->reserve(t_rest_words__arraylength);
	const_byteptr t_rest_words__elem__dataptr = (t_begin_of_data + 25);
	for (; t_rest_words__elem__it < t_rest_words__arraylength; ++t_rest_words__elem__it)
		{
		// Checking out-of-bound for "SMB_write_andx:rest_words__elem"
		if ( t_rest_words__elem__dataptr + (1) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_write_andx:rest_words__elem",
				((t_rest_words__elem__dataptr - t_begin_of_data)) + (1), 
				(t_end_of_data) - (t_begin_of_data));
			}
		rest_words__elem_ = *((uint8 const *) (t_rest_words__elem__dataptr));
		rest_words_->push_back(rest_words__elem_);
		t_rest_words__elem__dataptr += 1;
		BINPAC_ASSERT(t_rest_words__elem__dataptr <= t_end_of_data);
		// Check &until(rest_words__elem__dataptr >= end_of_data)
		if ( t_rest_words__elem__dataptr >= t_end_of_data )
			{
			goto end_of_rest_words;
			}
		}
end_of_rest_words: ;
	t_rest_words__size = t_rest_words__elem__dataptr - ((t_begin_of_data + 25));
	
	const_byteptr const t_dataptr_after_rest_words = (t_begin_of_data + 25) + (t_rest_words__size);
	BINPAC_ASSERT(t_dataptr_after_rest_words <= t_end_of_data);
	// Checking out-of-bound for "SMB_write_andx:byte_count"
	if ( t_dataptr_after_rest_words + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:byte_count",
			((t_dataptr_after_rest_words - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) (t_dataptr_after_rest_words)));
	
	
	const_byteptr t_dataptr_after_pad = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad < (t_dataptr_after_rest_words + 2) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:157:pad", (t_dataptr_after_rest_words + 2) - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad = (t_dataptr_after_rest_words + 2);
		}
	// Parse "data"
	int t_data__size;
	data_length_ = data_len_high() * 0x10000 + data_len();
	t_data__size = data_length();
	// Checking out-of-bound for "SMB_write_andx:data"
	if ( t_dataptr_after_pad + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx:data",
			((t_dataptr_after_pad - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad + t_data__size;
	int t_data_string_length;
	t_data_string_length = data_length();
	data_.init(t_dataptr_after_pad, t_data_string_length);
	}
	
	int t_SMB_write_andx__size;
	const_byteptr const t_dataptr_after_data = t_dataptr_after_pad + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_SMB_write_andx__size = t_dataptr_after_data - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_write_andx__size) <= t_end_of_data);
	return t_SMB_write_andx__size;
	}

SMB_write_andx_response::SMB_write_andx_response()
	{
	word_count_ = 0;
	andx_ = 0;
	count_ = 0;
	remaining_ = 0;
	reserved_ = 0;
	byte_count_ = 0;
	byteorder_ = littleendian;
	}

SMB_write_andx_response::~SMB_write_andx_response()
	{
	delete andx_;
	andx_ = 0;
	}

int SMB_write_andx_response::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_write_andx_response"
	if ( t_begin_of_data + (15) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_write_andx_response",
			(0) + (15), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "andx"
	andx_ = new SMB_andx();
	andx_->Parse((t_begin_of_data + 1), t_end_of_data, byteorder());
	
	// Parse "count"
	count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "remaining"
	remaining_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "reserved"
	reserved_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 9))));
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 13))));
	
	BINPAC_ASSERT(t_begin_of_data + (15) <= t_end_of_data);
	return 15;
	}

SMB_transaction::SMB_transaction(int trans_type, bool unicode)
	{
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	max_param_count_ = 0;
	max_data_count_ = 0;
	max_setup_count_ = 0;
	reserved_ = 0;
	flags_ = 0;
	timeout_ = 0;
	reserved2_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	setup_count_ = 0;
	reserved3_ = 0;
	setup_ = 0;
	setup__elem_ = 0;
	byte_count_ = 0;
	name_u_case_index_ = -1;
	name_ = 0;
	trans_type_ = trans_type;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_transaction::~SMB_transaction()
	{
	delete setup_;
	switch ( name_u_case_index() )
		{
		case 1:
			// Clean up "name"
			{
			delete name_;
			name_ = 0;
			}
			break;
		case 2:
			// Clean up "null"
			{
			}
			break;
		}
	parameters_.free();
	data_.free();
	}

int SMB_transaction::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_transaction:reserved3"
	if ( (t_begin_of_data + 28) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:reserved3",
			(28) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 1))));
	
	// Parse "total_data_count"
	total_data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 3))));
	
	// Parse "max_param_count"
	max_param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "max_data_count"
	max_data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "max_setup_count"
	max_setup_count_ = *((uint8 const *) ((t_begin_of_data + 9)));
	
	// Parse "reserved"
	reserved_ = *((uint8 const *) ((t_begin_of_data + 10)));
	
	// Parse "flags"
	flags_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 11))));
	
	// Parse "timeout"
	timeout_ = FixByteOrder(byteorder(), *((uint32 const *) ((t_begin_of_data + 13))));
	
	// Parse "reserved2"
	reserved2_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 17))));
	
	// Parse "param_count"
	param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 19))));
	
	// Parse "param_offset"
	param_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 21))));
	
	// Parse "data_count"
	data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 23))));
	
	// Parse "data_offset"
	data_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 25))));
	
	// Parse "setup_count"
	setup_count_ = *((uint8 const *) ((t_begin_of_data + 27)));
	
	// Parse "reserved3"
	reserved3_ = *((uint8 const *) ((t_begin_of_data + 28)));
	
	// Parse "setup"
	int t_setup__arraylength;
	t_setup__arraylength = setup_count();
	setup__elem_ = 0;
	int t_setup__elem__it;
	t_setup__elem__it = 0;
	int t_setup__size;
	setup_ = new vector<uint16>;
	setup_->reserve(t_setup__arraylength);
	const_byteptr t_setup__elem__dataptr = (t_begin_of_data + 29);
	for (; t_setup__elem__it < t_setup__arraylength; ++t_setup__elem__it)
		{
		// Checking out-of-bound for "SMB_transaction:setup__elem"
		if ( t_setup__elem__dataptr + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_transaction:setup__elem",
				((t_setup__elem__dataptr - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		setup__elem_ = FixByteOrder(byteorder(), *((uint16 const *) (t_setup__elem__dataptr)));
		setup_->push_back(setup__elem_);
		t_setup__elem__dataptr += 2;
		BINPAC_ASSERT(t_setup__elem__dataptr <= t_end_of_data);
		// Check &until(setup__elem__dataptr >= end_of_data)
		if ( t_setup__elem__dataptr >= t_end_of_data )
			{
			goto end_of_setup;
			}
		}
end_of_setup: ;
	t_setup__size = t_setup__elem__dataptr - ((t_begin_of_data + 29));
	
	const_byteptr const t_dataptr_after_setup = (t_begin_of_data + 29) + (t_setup__size);
	BINPAC_ASSERT(t_dataptr_after_setup <= t_end_of_data);
	// Checking out-of-bound for "SMB_transaction:byte_count"
	if ( t_dataptr_after_setup + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:byte_count",
			((t_dataptr_after_setup - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) (t_dataptr_after_setup)));
	
	// Parse "name_u"
	int t_name_u__size;
	name_u_case_index_ = trans_type();
	switch ( name_u_case_index() )
		{
		case 1:
			// Parse "name"
			{
			name_ = new SMB_string(unicode(), ((t_dataptr_after_setup + 2) - t_begin_of_data));
			int t_name__size;
			t_name__size = name_->Parse((t_dataptr_after_setup + 2), t_end_of_data, byteorder());
			t_name_u__size = t_name__size;
			}
			break;
		case 2:
			// Parse "null"
			{
			t_name_u__size = 0;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("SMB_transaction", name_u_case_index());
			break;
		}
	
	
	const_byteptr const t_dataptr_after_name_u = (t_dataptr_after_setup + 2) + (t_name_u__size);
	BINPAC_ASSERT(t_dataptr_after_name_u <= t_end_of_data);
	const_byteptr t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length);
	if ( t_dataptr_after_pad0 < t_dataptr_after_name_u )
		{
		// throw ExceptionInvalidOffset("./smb.pac:195:pad0", t_dataptr_after_name_u - t_begin_of_data, param_offset() - smb_header_length);
		t_dataptr_after_pad0 = t_dataptr_after_name_u;
		}
	// Parse "parameters"
	int t_parameters__size;
	t_parameters__size = param_count();
	// Checking out-of-bound for "SMB_transaction:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad0 + t_parameters__size;
	int t_parameters_string_length;
	t_parameters_string_length = param_count();
	parameters_.init(t_dataptr_after_pad0, t_parameters_string_length);
	}
	
	
	const_byteptr const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	BINPAC_ASSERT(t_dataptr_after_parameters <= t_end_of_data);
	const_byteptr t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:197:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__size;
	t_data__size = data_count();
	// Checking out-of-bound for "SMB_transaction:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad1 + t_data__size;
	int t_data_string_length;
	t_data_string_length = data_count();
	data_.init(t_dataptr_after_pad1, t_data_string_length);
	}
	
	int t_SMB_transaction__size;
	const_byteptr const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_SMB_transaction__size = t_dataptr_after_data - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_transaction__size) <= t_end_of_data);
	return t_SMB_transaction__size;
	}

SMB_transaction_secondary::SMB_transaction_secondary(bool unicode)
	{
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	param_displacement_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	data_displacement_ = 0;
	fid_ = 0;
	byte_count_ = 0;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_transaction_secondary::~SMB_transaction_secondary()
	{
	parameters_.free();
	data_.free();
	}

int SMB_transaction_secondary::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_transaction_secondary:byte_count"
	if ( (t_begin_of_data + 19) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:byte_count",
			(19) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 1))));
	
	// Parse "total_data_count"
	total_data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 3))));
	
	// Parse "param_count"
	param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "param_offset"
	param_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "param_displacement"
	param_displacement_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 9))));
	
	// Parse "data_count"
	data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 11))));
	
	// Parse "data_offset"
	data_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 13))));
	
	// Parse "data_displacement"
	data_displacement_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 15))));
	
	// Parse "fid"
	fid_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 17))));
	
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 19))));
	
	
	const_byteptr t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length);
	if ( t_dataptr_after_pad0 < (t_begin_of_data + 21) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:213:pad0", (t_begin_of_data + 21) - t_begin_of_data, param_offset() - smb_header_length);
		t_dataptr_after_pad0 = (t_begin_of_data + 21);
		}
	// Parse "parameters"
	int t_parameters__size;
	t_parameters__size = param_count();
	// Checking out-of-bound for "SMB_transaction_secondary:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad0 + t_parameters__size;
	int t_parameters_string_length;
	t_parameters_string_length = param_count();
	parameters_.init(t_dataptr_after_pad0, t_parameters_string_length);
	}
	
	
	const_byteptr const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	BINPAC_ASSERT(t_dataptr_after_parameters <= t_end_of_data);
	const_byteptr t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:215:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__size;
	t_data__size = data_count();
	// Checking out-of-bound for "SMB_transaction_secondary:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_secondary:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad1 + t_data__size;
	int t_data_string_length;
	t_data_string_length = data_count();
	data_.init(t_dataptr_after_pad1, t_data_string_length);
	}
	
	int t_SMB_transaction_secondary__size;
	const_byteptr const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_SMB_transaction_secondary__size = t_dataptr_after_data - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_transaction_secondary__size) <= t_end_of_data);
	return t_SMB_transaction_secondary__size;
	}

SMB_transaction_response::SMB_transaction_response(bool unicode)
	{
	word_count_ = 0;
	total_param_count_ = 0;
	total_data_count_ = 0;
	reserved_ = 0;
	param_count_ = 0;
	param_offset_ = 0;
	param_displacement_ = 0;
	data_count_ = 0;
	data_offset_ = 0;
	data_displacement_ = 0;
	setup_count_ = 0;
	reserved2_ = 0;
	setup_ = 0;
	setup__elem_ = 0;
	byte_count_ = 0;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_transaction_response::~SMB_transaction_response()
	{
	delete setup_;
	parameters_.free();
	data_.free();
	}

int SMB_transaction_response::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_transaction_response:reserved2"
	if ( (t_begin_of_data + 20) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:reserved2",
			(20) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "word_count"
	word_count_ = *((uint8 const *) (t_begin_of_data));
	
	// Parse "total_param_count"
	total_param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 1))));
	
	// Parse "total_data_count"
	total_data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 3))));
	
	// Parse "reserved"
	reserved_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 5))));
	
	// Parse "param_count"
	param_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 7))));
	
	// Parse "param_offset"
	param_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 9))));
	
	// Parse "param_displacement"
	param_displacement_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 11))));
	
	// Parse "data_count"
	data_count_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 13))));
	
	// Parse "data_offset"
	data_offset_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 15))));
	
	// Parse "data_displacement"
	data_displacement_ = FixByteOrder(byteorder(), *((uint16 const *) ((t_begin_of_data + 17))));
	
	// Parse "setup_count"
	setup_count_ = *((uint8 const *) ((t_begin_of_data + 19)));
	
	// Parse "reserved2"
	reserved2_ = *((uint8 const *) ((t_begin_of_data + 20)));
	
	// Parse "setup"
	int t_setup__arraylength;
	t_setup__arraylength = setup_count();
	setup__elem_ = 0;
	int t_setup__elem__it;
	t_setup__elem__it = 0;
	int t_setup__size;
	setup_ = new vector<uint16>;
	setup_->reserve(t_setup__arraylength);
	const_byteptr t_setup__elem__dataptr = (t_begin_of_data + 21);
	for (; t_setup__elem__it < t_setup__arraylength; ++t_setup__elem__it)
		{
		// Checking out-of-bound for "SMB_transaction_response:setup__elem"
		if ( t_setup__elem__dataptr + (2) > t_end_of_data )
			{
			// Handle out-of-bound condition
			throw ExceptionOutOfBound("SMB_transaction_response:setup__elem",
				((t_setup__elem__dataptr - t_begin_of_data)) + (2), 
				(t_end_of_data) - (t_begin_of_data));
			}
		setup__elem_ = FixByteOrder(byteorder(), *((uint16 const *) (t_setup__elem__dataptr)));
		setup_->push_back(setup__elem_);
		t_setup__elem__dataptr += 2;
		BINPAC_ASSERT(t_setup__elem__dataptr <= t_end_of_data);
		// Check &until(setup__elem__dataptr >= end_of_data)
		if ( t_setup__elem__dataptr >= t_end_of_data )
			{
			goto end_of_setup;
			}
		}
end_of_setup: ;
	t_setup__size = t_setup__elem__dataptr - ((t_begin_of_data + 21));
	
	const_byteptr const t_dataptr_after_setup = (t_begin_of_data + 21) + (t_setup__size);
	BINPAC_ASSERT(t_dataptr_after_setup <= t_end_of_data);
	// Checking out-of-bound for "SMB_transaction_response:byte_count"
	if ( t_dataptr_after_setup + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:byte_count",
			((t_dataptr_after_setup - t_begin_of_data)) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte_count"
	byte_count_ = FixByteOrder(byteorder(), *((uint16 const *) (t_dataptr_after_setup)));
	
	
	const_byteptr t_dataptr_after_pad0 = t_begin_of_data + (param_offset() - smb_header_length);
	if ( t_dataptr_after_pad0 < (t_dataptr_after_setup + 2) )
		{
		// throw ExceptionInvalidOffset("./smb.pac:234:pad0", (t_dataptr_after_setup + 2) - t_begin_of_data, param_offset() - smb_header_length);
		t_dataptr_after_pad0 = (t_dataptr_after_setup + 2);
		}
	// Parse "parameters"
	int t_parameters__size;
	t_parameters__size = param_count();
	// Checking out-of-bound for "SMB_transaction_response:parameters"
	if ( t_dataptr_after_pad0 + (t_parameters__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:parameters",
			((t_dataptr_after_pad0 - t_begin_of_data)) + (t_parameters__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad0 + t_parameters__size;
	int t_parameters_string_length;
	t_parameters_string_length = param_count();
	parameters_.init(t_dataptr_after_pad0, t_parameters_string_length);
	}
	
	
	const_byteptr const t_dataptr_after_parameters = t_dataptr_after_pad0 + (t_parameters__size);
	BINPAC_ASSERT(t_dataptr_after_parameters <= t_end_of_data);
	const_byteptr t_dataptr_after_pad1 = t_begin_of_data + (data_offset() - smb_header_length);
	if ( t_dataptr_after_pad1 < t_dataptr_after_parameters )
		{
		// throw ExceptionInvalidOffset("./smb.pac:236:pad1", t_dataptr_after_parameters - t_begin_of_data, data_offset() - smb_header_length);
		t_dataptr_after_pad1 = t_dataptr_after_parameters;
		}
	// Parse "data"
	int t_data__size;
	t_data__size = data_count();
	// Checking out-of-bound for "SMB_transaction_response:data"
	if ( t_dataptr_after_pad1 + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_transaction_response:data",
			((t_dataptr_after_pad1 - t_begin_of_data)) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_dataptr_after_pad1 + t_data__size;
	int t_data_string_length;
	t_data_string_length = data_count();
	data_.init(t_dataptr_after_pad1, t_data_string_length);
	}
	
	int t_SMB_transaction_response__size;
	const_byteptr const t_dataptr_after_data = t_dataptr_after_pad1 + (t_data__size);
	BINPAC_ASSERT(t_dataptr_after_data <= t_end_of_data);
	t_SMB_transaction_response__size = t_dataptr_after_data - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_transaction_response__size) <= t_end_of_data);
	return t_SMB_transaction_response__size;
	}

SMB_get_dfs_referral::SMB_get_dfs_referral(bool unicode)
	{
	max_referral_level_ = 0;
	file_name_ = 0;
	unicode_ = unicode;
	byteorder_ = littleendian;
	}

SMB_get_dfs_referral::~SMB_get_dfs_referral()
	{
	delete file_name_;
	file_name_ = 0;
	}

int SMB_get_dfs_referral::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SMB_get_dfs_referral:max_referral_level"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("SMB_get_dfs_referral:max_referral_level",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "max_referral_level"
	max_referral_level_ = FixByteOrder(byteorder(), *((uint16 const *) (t_begin_of_data)));
	
	// Parse "file_name"
	file_name_ = new SMB_string(unicode(), 2);
	int t_file_name__size;
	t_file_name__size = file_name_->Parse((t_begin_of_data + 2), t_end_of_data, byteorder());
	
	int t_SMB_get_dfs_referral__size;
	const_byteptr const t_dataptr_after_file_name = (t_begin_of_data + 2) + (t_file_name__size);
	BINPAC_ASSERT(t_dataptr_after_file_name <= t_end_of_data);
	t_SMB_get_dfs_referral__size = t_dataptr_after_file_name - t_begin_of_data;
	BINPAC_ASSERT(t_begin_of_data + (t_SMB_get_dfs_referral__size) <= t_end_of_data);
	return t_SMB_get_dfs_referral__size;
	}

} // namespace SMB
}  // namespace binpac
